function c = inspRealPlot(axis)
global traceIndex
global SeisData
global SACdata

cla
index = traceIndex;
time = linspace(SACdata(index).times.b, SACdata(index).times.e,SACdata(index).trcLen);
y = SeisData(:,index) - mean(SeisData(:,index));
NPTS = SACdata(index).trcLen;
c = line('Parent',axis, ...
	'Color',[0 0 1], ...
	'Tag','Seismogram', ...
	'XData',time, ...
	'YData',y(1:NPTS) );
	
xlabel('Time (seconds)')
ylabel('amplitude (units?)')
	
range = max(y) - min(y);
	
bottom = mean(y) -range/8;

if ~isempty(SACdata(index).times.t0)
   t = SACdata(index).times.t0;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt0;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t1)
   t = SACdata(index).times.t1;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt1;
   if ~isempty(string), h = text(t,bottom,string); end;
end		


if ~isempty(SACdata(index).times.t2)
   t = SACdata(index).times.t2;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt2;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t3)
   t = SACdata(index).times.t3;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt3;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t4)
   t = SACdata(index).times.t4;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt4;
   if ~isempty(string), h = text(t,bottom,string); end;
end		


if ~isempty(SACdata(index).times.t5)
   t = SACdata(index).times.t5;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt5;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t6)
   t = SACdata(index).times.t6;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt6;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t7)
   t = SACdata(index).times.t7;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt7;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t8)
   t = SACdata(index).times.t8;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt8;
   if ~isempty(string), h = text(t,bottom,string); end;
end		

if ~isempty(SACdata(index).times.t9)
   t = SACdata(index).times.t9;
   h=line([t,t], [bottom,bottom+range/4], 'color','r');
   string = SACdata(index).times.kt9;
   if ~isempty(string), h = text(t,bottom,string); end;
end		






hTxtWin = findobj('Tag','FigTextWin');
if isempty(hTxtWin)
   hTxtWin = uicontrol('Parent',gcf, ...
	    'Units','points', ...
	    'BackgroundColor',[1 1 1], ...
	    'Position',[570 350 150 60], ...
	    'Style','frame', ...
	    'Tag','FigTextWin');

end

label = cell(4,1);
label{1} = SACdata(index).station.kstnm;
label{2} = SACdata(index).station.kcmpnm;
timedate = [num2str(SACdata(index).event.nzyear) ' 'num2str(SACdata(index).event.nzjday)];
timedate = [timedate ' 'num2str(SACdata(index).event.nzhour) ' 'num2str(SACdata(index).event.nzmin)];
timedate = [timedate ' 'num2str(SACdata(index).event.nzsec) ];
label{3} =  timedate;
label{4} =  SACdata(index).event.kevnm;


hTxtString = findobj('Tag','plotLabel');
if ~isempty(hTxtString)
   delete(hTxtString)
end


hTxtString = uicontrol('Parent',gcf, ...
	    'Units','points', ...
	    'BackgroundColor',[1 1 1], ...
	    'Position',[570 350 150 60], ...
	    'Style','text', ...
	    'string',label, ...
	    'HorizontalAlignment','left', ...
	    'Tag','plotLabel');



