global traceIndex
global SeisData
global SACdata
global BlackBoard
global Ntraces

traceIndex = 1;
[MaxLength,Ntraces] = size(SeisData);
screen = get(0,'ScreenSize'); 
width = 960;
height = 625;
left = (screen(3) - width)/2;
bot = (screen(4) - height)/2;
a = figure('Color',[0.8 0.8 0.8], ...
	'Name','SAC data Inspector', ...
	'NumberTitle','off', ...
	'MenuBar','none', ...
	'Position',[left, bot, width, height], ...
	'WindowButtonUpFcn','inspCallbacks(''Delete'')', ...
	'Tag','Fig1');
b = axes('Parent',a, ...
	'Box','on', ...
	'CameraUpVector',[0 1 0], ...
	'Color',[1 1 1], ...
	'Position',[0.0994695 0.101449 0.803714 0.695652], ...
	'Tag','Axes1', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0], ...
	'ZColor',[0 0 0]);
seisHandle = inspRealPlot(b);	



% *************************** Setup frame and pushbuttons ******************************
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.5 0.5 0.8], ...
	'Position',[10.1647 448.094 664.094 73.6941], ...
	'Style','frame', ...
	'Tag','ToolBar');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[20.3294 457.412 77.0824 24.5647], ...
	'String','Times struct', ...
	'Callback','inspCallbacks(''time'')', ...
	'Tag','Times');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[100.8 457.412 77.0824 24.5647], ...
	'String','Station struct', ...
	'Callback','inspCallbacks(''stat'')', ...
	'Tag','Station');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[182.118 457.412 77.0824 24.5647], ...
	'String','Event struct', ...
	'Callback','inspCallbacks(''event'')', ...
	'Tag','Event');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[263.435 457.412 77.0824 24.5647], ...
	'String','user struct', ...
	'Callback','inspCallbacks(''user'')', ...
	'Tag','User');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[343.906 457.412 77.0824 24.5647], ...
	'String','Descrip struct', ...
	'Callback','inspCallbacks(''descrip'')', ...
	'Tag','Descrip');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[425.224 457.412 77.0824 24.5647], ...
	'String','evsta struct', ...
	'Callback','inspCallbacks(''evsta'')', ...
	'Tag','Evsta');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[506.541 457.412 77.0824 24.5647], ...
	'String','llnl struct', ...
	'Callback','inspCallbacks(''llnl'')', ...
	'Tag','llnl');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[587.859 457.412 77.0824 24.5647], ...
	'String','Response struct', ...
	'Callback','inspCallbacks(''response'')', ...
	'Tag','response');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'Position',[21.1765 491.294 123.671 22.0235], ...
	'String','Previous Trace', ...
	'Callback','inspCallbacks(''prev'')', ...
	'Enable','off', ...
	'Tag','Previous');
b = uicontrol('Parent',a, ...
	'Units','points', ...
	'Position',[536.188 491.294 123.671 22.0235], ...
	'String','Next Trace', ...
	'Callback','inspCallbacks(''next'')', ...
	'Tag','Next');
	
	
if Ntraces < 2,set(b,'enable','off'),end

b = uicontrol('Parent',a, ...
	'Units','points', ...
	'Position',[350.188 491.294 150 22.0235], ...
	'BackgroundColor', [0.901961 0.701961 0.7], ...
	'String','Quit', ...
	'Callback','close', ...
	'Tag','close');

if ~isempty(BlackBoard)	
   b = uicontrol('Parent',a, ...
	'Units','points', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[182.118 491.294 77.0824 24.5647], ...
	'String','Blackboard struct', ...
	'Callback','inspCallbacks(''bboard'')', ...
	'Tag','BlackBoard');
end	


imzoom on	
	
