function OK = prs
global SACdata
global SeisData
global WAITFORQUIT
global ToolBarBtn
global NumZooms
global XstackManPick
global YstackManPick
global SourceDepth
global DistanceVec
global PhaseList
global PhasePatch
global HeaderNameAvailable 
global Seis
global PlotState
global PickSelected
global PickTolerance
global ScaleFactor
global WaitForPick
global PickWin
global LastPhaseSet
global hSLIDERWIN               % handle to progress slider control
global hSLIDERDONE              % handle to done fraction
global hSLIDERTOTAL             % handle to total fraction of slider control


ToolBarBtn = zeros(8,1);
NumZooms = 0;
XstackManPick = [];
YstackManPick = [];
HeaderNameAvailable = ones(11,1);
MaxPts = 10000;
MaxDecimation = 20;
PickSelected = 0;
PickTolerance = 2;
WaitForPick = 0;
PlotState.Orientation = 'Horizontal';
PlotState.DistanceUnits = 'Kilometers';
PlotState.TimeUnits = 'Seconds';
PlotState.ShowPicks = 1;
PlotState.ShowPlaceHolders = 0;
PlotState.ShowNames = 0;
PickWin = [];
LastPhaseSet = 'P';


   
a = figure('Units','normalized', ...
	'Color',[0.8 0.8 0.8], ...
        'WindowButtonDownFcn','prsSetPicksMouseCallBacks(''btnDown'')',... 
        'WindowButtonMotionFcn','prsSetPicksMouseCallBacks(''btnMove'')',...
        'WindowButtonUpFcn','prsSetPicksMouseCallBacks(''btnUp'')',...
	'Position',[0.381944 0.02 0.595486 0.896667], ...
	'NumberTitle','off',...
	'Name','Record Section Plot',...
	'Menubar','none',...
	'Tag','RecSecPlot');
	
	
b = uimenu('Parent',a, ...
	'Label','Properties', ...
	'Tag','Properties');
	
c = uimenu('Parent',b, ...
	'Label','View Vertical', ...
	'Callback','prsSetPicksCallbacks(''Orientation'')',...
	'Tag','ViewOrientation');
if strcmp(PlotState.Orientation, 'Vertical')
   set(c,'label','View Horizontal')
end   	
	
c = uimenu('Parent',b, ...
	'Label','View Trace Markers', ...
	'Callback','prsSetPicksCallbacks(''TraceMarkers'')',...
	'Tag','ViewMarkers');
if PlotState.ShowPlaceHolders 
   set(c,'label','Hide Trace Markers')
end   	
	
c = uimenu('Parent',b, ...
	'Label','View Picks', ...
	'Callback','prsSetPicksCallbacks(''Picks'')',...
	'Tag','ViewPicks');
if PlotState.ShowPicks 
   set(c,'label','Hide Picks')
end   	
	
c = uimenu('Parent',b, ...
	'Label','View Station Names', ...
	'Callback','prsSetPicksCallbacks(''Names'')',...
	'Tag','ShowNames');
if PlotState.ShowNames 
   set(c,'label','Hide Station Names')
end   	

c = uimenu('Parent',b, ...
	'Label','Distance In Degrees', ...
	'Callback','prsSetPicksCallbacks(''DistUnits'')',...
	'Enable','off',...
	'Tag','DistUnits');
if strcmp(PlotState.DistanceUnits, 'Kilometers')
   set(c,'label','Distance In Degrees')
end   	

	
b = uimenu('Parent',a, ...
	'Label','Actions', ...
	'Tag','Actions');
	
c = uimenu('Parent',b, ...
	'Label','Design Filter', ...
	'Enable','off',...
	'Tag','DesignFilter');
	
c = uimenu('Parent',b, ...
	'Label','Print Section', ...
	'Callback','print -dpsc -noui',...
	'Tag','PrintSection');
	
c = uimenu('Parent',b, ...
	'Label','Select Subset', ...
	'Callback','prsTraceSubset',...
	'Tag','SelectSubset');
	

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.0    0.8879    1.0    0.0971], ...
	'Style','frame', ...
	'Tag','Frame1');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.03    0.9303    0.1003    0.0224], ...
	'String',' ', ...
	'Style','popupmenu', ...
	'Tag','PlistBox', ...
	'Value',1);
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.1524    0.9303    0.0984    0.0224], ...
	'String',' ', ...
	'Style','popupmenu', ...
	'Tag','SlistBox', ...
	'Value',1);
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.2765    0.9303    0.0984    0.0224], ...
	'String',' ', ...
	'Style','popupmenu', ...
	'Tag','plistBox', ...
	'Value',1);
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.4006    0.9303    0.0984    0.0224], ...
	'String',' ', ...
	'Style','popupmenu', ...
	'Tag','slistBox', ...
	'Value',1);
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.5247    0.9303    0.0984    0.0224], ...
	'String',' ', ...
	'Style','popupmenu', ...
	'Tag','MorelistBox', ...
	'Value',1);
			
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.0226    0.955    0.1184    0.025], ...
	'String','Down-going P', ...
	'Style','text', ...
	'Tag','StaticText1');
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.1438    0.955    0.1184    0.025], ...
	'String','Down-going S', ...
	'Style','text', ...
	'Tag','StaticText1');	
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.2665    0.955    0.1184    0.025], ...
	'String','Up-going P', ...
	'Style','text', ...
	'Tag','StaticText1');	
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.3892    0.955    0.1184    0.025], ...
	'String','Up-going S', ...
	'Style','text', ...
	'Tag','StaticText1');	
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.5119    0.955    0.1184    0.025], ...
	'String','More Phases', ...
	'Style','text', ...
	'Enable','off',...
	'Tag','StaticText1');
	

%   This is the pick list that pops up when a pick is created with the mouse.	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.5    0.5    0.1184    0.025], ...
	'String','P', ...
	'Style','popupmenu', ...
	'Callback','global WaitForPick, WaitForPick = 0;',...
	'Visible', 'off',...
	'Tag','PickList');
	
		

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[0.72    0.9539    0.12    0.0224], ...
	'String','Refresh', ...
	'Callback','prsSetPicksCallbacks(''Refresh'')',...
	'Tag','Refresh');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[0.72    0.9265    0.12    0.0224], ...
	'String','SavePicks', ...
	'Callback','prsSetPicksCallbacks(''SavePicks'')',...
	'Tag','SavePicks');	
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.72    0.8979    0.12    0.0224], ...
	'Enable','off',...
	'String','Pick Window', ...
	'Callback','prsSetPicksCallbacks(''PickWindow'')',...
	'Tag','PickWindow');


	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[0.86    0.9539    0.12    0.0224], ...
	'Enable','off',...
	'String','Set Filter', ...
	'Callback','prsSetPicksCallbacks(''SetFilter'')',...
	'Tag','SetFilter');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[0.86    0.9265    0.12    0.0224], ...
	'String','Filter All', ...
	'Enable','off',...
	'Callback','prsSetPicksCallbacks(''FilterAll'')',...
	'Tag','FilterAll');	
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.86    0.8979    0.12    0.0224], ...
	'String','Close', ...
	'Callback','prsSetPicksCallbacks(''Close'')',...
	'Tag','Close');
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.03    0.9050    0.0502    0.0224], ...
	'String','Add', ...
	'Callback','prsSetPicksCallbacks(''AddP'')',...
	'Tag','AddP');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.0802    0.9050    0.0502    0.0224], ...
	'String','Del', ...
	'Callback','prsSetPicksCallbacks(''DelP'')',...
	'Tag','DelP');
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.1524    0.9050    0.0502    0.0224], ...
	'String','Add', ...
	'Callback','prsSetPicksCallbacks(''AddS'')',...
	'Tag','AddS');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.2026    0.9050    0.0502    0.0224], ...
	'String','Del', ...
	'Callback','prsSetPicksCallbacks(''DelS'')',...
	'Tag','DelS');
	
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.2765    0.9050    0.0502    0.0224], ...
	'String','Add', ...
	'Callback','prsSetPicksCallbacks(''Addp'')',...
	'Tag','Addp');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.3267    0.9050    0.0502    0.0224], ...
	'String','Del', ...
	'Callback','prsSetPicksCallbacks(''Delp'')',...
	'Tag','Delp');
					
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.4006    0.9050    0.0502    0.0224], ...
	'String','Add', ...
	'Callback','prsSetPicksCallbacks(''Adds'')',...
	'Tag','Adds');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.4508    0.9050    0.0502    0.0224], ...
	'String','Del', ...
	'Callback','prsSetPicksCallbacks(''Dels'')',...
	'Tag','Dels');
					
b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.5247    0.9050    0.0502    0.0224], ...
	'String','Add', ...
	'Callback','prsSetPicksCallbacks(''AddM'')',...
	'Tag','AddM');

b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.5749    0.9050    0.0502    0.0224], ...
	'String','Del', ...
	'Callback','prsSetPicksCallbacks(''DelM'')',...
	'Tag','DelM');

% ------------- Add the toolbar to window ---------------					
prsToolBar



b = axes('Parent',a, ...
	'Units','normalized', ...
	'Box','on', ...
	'Color',[1 1 1], ...
	'Position',[0.1414    0.0755    0.7551    0.7760], ...
	'Tag','RecSecAxis', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0]);
rsa = b;	


b = uicontrol('Parent',a, ...
 	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.1414    0.8515    0.7551    0.0224], ...
	'Style','slider', ...
	'visible','off',...
        'CallBack','prsSetPicksMouseCallBacks(''hScroll'')',...
	'Tag','HscrollBar'); 


b = uicontrol('Parent',a, ...
 	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.8965    0.0755    0.0224    0.7760], ...
	'Style','slider', ...
	'visible','off',...
        'CallBack','prsSetPicksMouseCallBacks(''vScroll'')',...
	'Tag','VscrollBar'); 


b = uicontrol('Parent',a, ...
 	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.0    0.0    0.1    0.028], ...
	'Style','popupmenu', ...
	'visible','off',...
        'CallBack','prsSetPicksMouseCallBacks(''ChangeHeaderName'')',...
	'Tag','pickMarkerPopUp'); 
	
% ---- Populate the list box just created with the possible header values for picks	
string{1} = 'A';
for j=1:10
   string{j+1} = ['T' num2str(j-1)];
end
set(b,'string',string)   




b = uicontrol('Parent',a, ...
 	'Units','normalized', ...
	'BackgroundColor','c', ...
	'Position',[0.0    0.0    0.3    0.028], ...
	'Style','text', ...
	'visible','off',...
	'Tag','phaseIDPopUp'); 


% Now add all the phases that can be displayed to list boxes
FillListBoxes

% ------- Load seismogram header info into structure array ------
minDist = 10000;
maxDist = 0;
minGcarc = 10000;
maxGcarc = 0;
maxTime = -1;
TotalFiles = length(SACdata);
 
for j=1:TotalFiles
   if SACdata(j).times.e > maxTime, maxTime = SACdata(j).times.e;end
   Seis(j).Stla = SACdata(j).station.stla;
   Seis(j).Stlo = SACdata(j).station.stlo;
   Seis(j).Evla = SACdata(j).event.evla;
   Seis(j).Evlo = SACdata(j).event.evlo;
   Seis(j).Dist = SACdata(j).evsta.dist;
   Seis(j).Gcarc = SACdata(j).evsta.gcarc;
   Seis(j).Depth = SACdata(j).event.evdp;
   if ~isempty(SACdata(j).station.kstnm)
      Seis(j).Name = deblank(SACdata(j).station.kstnm);
   else
      Seis(j).Name = ' ';
   end
   if ~isempty(SACdata(j).station.kcmpnm)
      Seis(j).Component = deblank(SACdata(j).station.kcmpnm);
   else
      Seis(j).Component = ' ';
   end
   Seis(j).Cmpinc = SACdata(j).station.cmpinc;
   Seis(j).Cmpaz = SACdata(j).station.cmpaz;
   if ~isempty(SACdata(j).event.kevnm)
      Seis(j).Event = deblank(SACdata(j).event.kevnm);
   else
      Seis(j).Event = ' ';
   end
   [Seis(j), OK] = CheckSACdata(Seis(j));
   if ~OK, return,end
   [Seis(j).Npicks, Seis(j).Pick] = AddPicksInHeader(SACdata, j);
   if Seis(j).Dist < minDist, minDist = Seis(j).Dist; end
   if Seis(j).Dist > maxDist, maxDist = Seis(j).Dist; end
   if Seis(j).Gcarc < minGcarc, minGcarc = Seis(j).Gcarc; end
   if Seis(j).Gcarc > maxGcarc, maxGcarc = Seis(j).Gcarc; end
end
if maxDist > 1000, PlotState.DistanceUnits = 'Degrees';end
if strcmp(PlotState.DistanceUnits , 'Degrees')
   ScaleFactor = (maxGcarc - minGcarc) / 25;
else   
   ScaleFactor = (maxDist - minDist) / 25;
end

if maxTime > 900, PlotState.TimeUnits = 'Minutes';end
if strcmp(PlotState.TimeUnits , 'Minutes')
   PickTolerance = PickTolerance /60;
end
ylabel(['Distance (' PlotState.DistanceUnits ')'])
xlabel(['Time (' PlotState.TimeUnits ')'])



% Create a patch used to display model pick uncertainties.
% Leave it invisible for now.
Xdata = [1 1 0  0];
Ydata = [0 1 1 0];
X = [Xdata+PickTolerance, fliplr(Xdata)-PickTolerance];
Y = [Ydata, fliplr(Ydata)];
PhasePatch.handle = patch(X,Y,[.8 .8 .8],'erasemode','xor');
set(PhasePatch.handle,'visible','off')
drawnow

% ------------------ plot the traces ------------
Tmax = 0;
OK = 0;
prsSlider
for j=1:TotalFiles
   t = SACdata(j).times.b:SACdata(j).times.delta:SACdata(j).times.e;
   t = t';
   y = SeisData(1:length(t),j);
   y = y - mean(y);
   range = max(y) - min(y);
   if range <= 0, range = 1; end
   factor = ScaleFactor / range;
   if strcmp(PlotState.TimeUnits , 'Minutes')
      t = t / 60;
   end
   Decimation = round(length(t) / MaxPts);
   if Decimation < 1, Decimation = 1; end
   if Decimation > MaxDecimation, Decimation = MaxDecimation; end
   tm = max(t);
   if tm > Tmax,Tmax = tm;end
   if strcmp(PlotState.DistanceUnits , 'Degrees')
      center = Seis(j).Gcarc;
      y = center + y * factor;
   else
      center = Seis(j).Dist;
      y = center + y * factor;
   end
   N = length(y);
   axes(rsa)
   Seis(j).TraceHandle = line(t(1:Decimation:N), y(1:Decimation:N), 'erasemode','background');
   Seis(j).Hidden = 0;
   for k=1:Seis(j).Npicks
      T = [ Seis(j).Pick(k).Time Seis(j).Pick(k).Time ];
      if strcmp(PlotState.TimeUnits , 'Minutes')
         T = T / 60;
      end

      R = [ center-ScaleFactor/4 center+ScaleFactor/4];
      Seis(j).Pick(k).LineHandle = line(T, R, 'color','r','erasemode','xor');
      Seis(j).Pick(k).TextHandle = text(T(1), R(1),Seis(j).Pick(k).Header,...
      				   'fontsize',8,'erasemode','xor');
      set(Seis(j).Pick(k).TextHandle,'clipping','on')      				   
      if ~PlotState.ShowPicks
         set(Seis(j).Pick(k).LineHandle,'visible','off')
         set(Seis(j).Pick(k).TextHandle,'visible','off')
      end
      				   
   end
   Seis(j).NameHandle = text(tm,center,Seis(j).Name,'fontsize',8,...
                        'erasemode','background','clipping','on');
   if ~PlotState.ShowNames
      set(Seis(j).NameHandle,'visible','off')
   end                        
   h = line([0, 1.1*Tmax], [center center], 'linestyle','--',...
          'visible','off','erasemode','xor');
   set(h, 'color',[.7 .7 .7],'linewidth',.1)
   Seis(j).TraceMarker = h;
   
   Extent = get(hSLIDERTOTAL,'position');
   MaxWidth = Extent(3);
   done = j / TotalFiles * MaxWidth;
   Extent(3) = done;
   set(hSLIDERDONE,'position',Extent)
   drawnow
   axes(rsa)   
end
close(hSLIDERWIN)

%  ---------------- set axis limits ------------------------
if strcmp(PlotState.DistanceUnits , 'Degrees')
   range = maxGcarc - minGcarc;
   minV = minGcarc - .1 * range;
   maxV = maxGcarc + .1 * range;
else
   range = maxDist - minDist;
   minV = minDist - .1 * range;
   maxV = maxDist + .1 * range;
end
if minV < 0
   minV = 0;
end
 
set(gca,'ylim',[minV maxV])
set(gca,'xlim',[0 1.1 * Tmax])


if strcmp(PlotState.Orientation , 'Vertical')
   set(gca,'view',[90 -90])
   h = findobj('Tag','ViewOrientation');
   set(h,'label','View Horizontal')
   hh = findobj('Tag','HscrollBar');
   hv = findobj('Tag','VscrollBar');
   ph = get(hh,'position');
   pv = get(hv,'position');
   tmp = ph;
   ph = pv;
   pv = tmp;
   set(hh,'position',ph)
   set(hv,'position',pv)
end
 
% -----------------  Plot the theoretical P arrival line -----------------
DistanceVec = GetDistanceVec(Seis);
SourceDepth = Seis(1).Depth;
phase = 'P ';
[tt,jnk1,jnk2,jnk3] = get_ttt(phase, SourceDepth, DistanceVec, 'iasp91');
if strcmp(PlotState.DistanceUnits , 'Degrees')
   dist = DistanceVec;
else
   for k=1:length(Seis)
      dist(k) = Seis(k).Dist;
   end
   dist = sort(dist);
end

if strcmp(PlotState.TimeUnits , 'Minutes')
   tt = tt / 60;
end 
  
h1 = line(tt, dist,'color','r','erasemode','background');
PhaseList.NumPhases = 1;
PhaseList.hPhase(PhaseList.NumPhases) = h1;
[dm, ii] = max(dist);
PhaseList.DisplayedPhase{PhaseList.NumPhases} = 'P';
PhaseList.HeaderName(PhaseList.NumPhases) = GetNextAvailableHeaderName;		      
PhasePatch.DisplayedPhase = 'P';
PhasePatch.HeaderName = 1;
PhasePatch.PhaseIndex = 1;



WAITFORQUIT = 1;
while 1
   drawnow
   if ~WAITFORQUIT,break,end
end

% ---------------------------------------------------------------------






function FillListBoxes
fid=fopen('PhaseList.m','rt');
if fid == -1
   error('Could not open PhaseList file!')
end

nP = 0;
np = 0;
nS = 0;
ns = 0;
Plist = [];
plist = [];
Slist = [];
slist = [];   
while 1
  line = fgetl(fid);
  if ~isstr(line), break, end
      if line(1) == 'P'
         nP = nP +1;
         Plist{nP} = line;
      end
      if line(1) == 'p'
         np = np +1;
         plist{np} = line;
      end
      if line(1) == 'S'
         nS = nS +1;
         Slist{nS} = line;
      end
      if line(1) == 's'
         ns = ns +1;
         slist{ns} = line;
      end
  end
fclose(fid);


h = findobj('Tag','PlistBox');
if ~isempty(h)
   set(h,'string',Plist');
end
h = findobj('Tag','SlistBox');
if ~isempty(h)
   set(h,'string',Slist');
end
h = findobj('Tag','plistBox');
if ~isempty(h)
   set(h,'string',plist');
end
h = findobj('Tag','slistBox');
if ~isempty(h)
   set(h,'string',slist');
end

h = findobj('Tag','PickList');
if ~isempty(h)
   set(h,'string',[Plist Slist plist slist]');
end


% ---------------------------------------------------------------------






function [Seis, OK] = CheckSACdata(Seis)
UNDEFINED = -12345;
OK = 0;
title = 'Problem with SAC file!';

if isempty(Seis.Stla)
   msgbox('STLA undefined in SAC header.', title,'error','modal')
   return;
end

if isempty(Seis.Stlo)
   msgbox('STLO undefined in SAC header.', title,'error','modal')
   return;
end

if isempty(Seis.Evla)
   msgbox('EVLA undefined in SAC header.', title,'error','modal')
   return;
end

if isempty(Seis.Evlo)
   msgbox('EVLO undefined in SAC header.', title,'error','modal')
   return;
end

if isempty(Seis.Depth)
   Seis.Depth = 30;
end

[delta, dist, azim, bazim] = delaz(Seis.Stla,Seis.Stlo, Seis.Evla, Seis.Evlo);
Seis.Dist = real(dist);
Seis.Gcarc = real(delta);   

OK = 1;
% ---------------------------------------------------------------------






function [Npicks, Pick] = AddPicksInHeader(SACdata,  index)

Npicks = 0;
Pick = struct('Time',[], 'Header',[]);

if ~isempty(SACdata(index).times.a)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.a;
   Pick( Npicks ).Header = 'A';
   if ~isempty(SACdata(index).times.ka)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.ka );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t0)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t0;
   Pick( Npicks ).Header = 'T0';
   if ~isempty(SACdata(index).times.kt0)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt0 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t1)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t1;
   Pick( Npicks ).Header = 'T1';
   if ~isempty(SACdata(index).times.kt1)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt1 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t2)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t2;
   Pick( Npicks ).Header = 'T2';
   if ~isempty(SACdata(index).times.kt2)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt2 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t3)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t3;
   Pick( Npicks ).Header = 'T3';
   if ~isempty(SACdata(index).times.kt3)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt3 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t4)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t4;
   Pick( Npicks ).Header = 'T4';
   if ~isempty(SACdata(index).times.kt4)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt4 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t5)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t5;
   Pick( Npicks ).Header = 'T5';
   if ~isempty(SACdata(index).times.kt5)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt5 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t6)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t6;
   Pick( Npicks ).Header = 'T6';
   if ~isempty(SACdata(index).times.kt6)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt6 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t7)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t7;
   Pick( Npicks ).Header = 'T7';
   if ~isempty(SACdata(index).times.kt7)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt7 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t8)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t8;
   Pick( Npicks ).Header = 'T8';
   if ~isempty(SACdata(index).times.kt8)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt8 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

if ~isempty(SACdata(index).times.t9)
   Npicks = Npicks + 1;
   Pick( Npicks ).Time = SACdata(index).times.t9;
   Pick( Npicks ).Header = 'T9';
   if ~isempty(SACdata(index).times.kt9)
      Pick( Npicks ).Phase = deblank( SACdata(index).times.kt9 );
   else
      Pick (Npicks ).Phase = ' ';
   end
end

% ---------------------------------------------------------------------





function DistanceVec = GetDistanceVec(Seis)

DistanceVec = zeros(1,length(Seis));
for j=1:length(Seis)
   DistanceVec(j) = Seis(j).Gcarc;
end
DistanceVec = sort(DistanceVec);
% ---------------------------------------------------------------------





   
function value = GetNextAvailableHeaderName
global HeaderNameAvailable 

value = 1;
for j=1:11
   if HeaderNameAvailable(j)
      HeaderNameAvailable(j) = 0;
      value = j;
      return
   end
end
% ---------------------------------------------------------------------

  