function prsEvStaMapCallBacks(value)

switch value
   case 'btnDown'
      HandleButtonPress
      
   case 'ExcludeV'
      ExcludeV   
      
   case 'ExcludeH'
      ExcludeH   
      
   case 'ExcludeH1'
      ExcludeH1   
      
   case 'ExcludeH2'
      ExcludeH2   

   case 'SelectAll'
      SelectAll
      
   case 'SelectNone'
      SelectNone
      
   case 'SelectRegion'
      SelectRegion
      
   case 'ClearRegion'
      ClearRegion
      
   otherwise, return
end
% ----------------------------------------------------------





function ExcludeV
global Seis

h = findobj('Tag','EvStaMapExcludeV');
if isempty(h),return,end
if get(h,'value')
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 0
         HideSeis(j)
         set(Seis(j).MapSta,'visible','off')
      end
   end
else
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 0
         set(Seis(j).MapSta,'visible','on')
      end
   end
   
end   
% ----------------------------------------------------------






function ExcludeH
global Seis

h = findobj('Tag','EvStaMapExcludeH');
if isempty(h),return,end
if get(h,'value')
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90 
         HideSeis(j)
         set(Seis(j).MapSta,'visible','off')
      end
   end
else
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90
         set(Seis(j).MapSta,'visible','on')
      end
   end
   
end   
% ----------------------------------------------------------






function ExcludeH1
global Seis

h = findobj('Tag','EvStaMapExcludeH1');
if isempty(h),return,end
if get(h,'value')
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90 & InH1Quadrant(Seis(j).Cmpaz) 
         HideSeis(j)
         set(Seis(j).MapSta,'visible','off')
      end
   end
else
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90 & InH1Quadrant(Seis(j).Cmpaz)
         set(Seis(j).MapSta,'visible','on')
      end
   end
   
end   
% ----------------------------------------------------------







function ExcludeH2
global Seis

h = findobj('Tag','EvStaMapExcludeH2');
if isempty(h),return,end
if get(h,'value')
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90 & InH2Quadrant(Seis(j).Cmpaz) 
         HideSeis(j)
         set(Seis(j).MapSta,'visible','off')
      end
   end
else
   for j=1:length(Seis)
      if Seis(j).Cmpinc == 90 & InH2Quadrant(Seis(j).Cmpaz)
         set(Seis(j).MapSta,'visible','on')
      end
   end
   
end   
% ----------------------------------------------------------



function ClearRegion
global EvStaMapPatchList

if isempty(EvStaMapPatchList)
   return
end
   
[x,y] = ginput(1);
hObj = gco;
for j=1:length(EvStaMapPatchList)
   if hObj == EvStaMapPatchList(j)
      delete(hObj)
      EvStaMapPatchList(j) = [];
      return
   end
end   
% ----------------------------------------------------------





function  HandleButtonPress
global Seis
global EvStaMapPatchList
 
hObj = gco;
for j=1:length(Seis)
   if hObj == Seis(j).MapSta
      ChangeVisibility(j)
      return
   end
end


xlimits = get(gca,'xlim');
ylimits = get(gca,'ylim');
StartPoint = get(gca,'currentpoint');
if StartPoint(1,1) < xlimits(1) | StartPoint(1,1) > xlimits(2)
   return
end
if StartPoint(1,2) < ylimits(1) | StartPoint(1,2) > ylimits(2)
   return
end
if strcmp(get(gcf,'selectiontype'),'alt')
   PopOffStack
   return
end

rect = rbbox;
if rect(3) ~= 0 & rect(4) ~= 0
   EndPoint = get(gca,'currentpoint');
   AddToStack(xlimits,ylimits);
   Xlim = [StartPoint(1,1),EndPoint(1,1)];
   if Xlim(1) > Xlim(2), Xlim = fliplr(Xlim);end
   Ylim = [StartPoint(2,2),EndPoint(2,2)];
   if Ylim(1) > Ylim(2), Ylim = fliplr(Ylim);end
   set(gca,'xlim',Xlim )
   set(gca,'ylim',Ylim )
   return
end

if ~isempty(EvStaMapPatchList)
   for j=1:length(EvStaMapPatchList)
      if hObj == EvStaMapPatchList(j)
         if strcmp(get(gcf,'selectiontype'),'extend')
            UnselectPatchContents(hObj)
            return
         end
         if strcmp(get(gcf,'selectiontype'),'normal')
            SelectPatchContents(hObj)
            return
         end 
      end
   end
end



% ----------------------------------------------------------





function [z, index] = GetCoordVector
global Seis

k=0;
z = [];
index = [];
for j=1:length(Seis)
   if ~isempty(Seis(j).MapSta)
      k=k+1;
      h = Seis(j).MapSta;
      pos = get(h,'position');
      z(k) = pos(1) + pos(2)*i;
      index(k) = j;
   end
   if ~isempty( Seis(j).MapEvent)
      k=k+1;
      h = Seis(j).MapEvent;
      pos = get(h,'position');
      z(k) = pos(1) + pos(2)*i;
      index(k) = j;
   end      
end 
% ----------------------------------------------------------




function SelectPatchContents(hObj)
global Seis

[z, index] = GetCoordVector;
x = get(hObj,'XData');
y = get(hObj,'YData');
w = x + y*i;

if ~isempty(z)
   for j = 1:length(z)
      if inside(z(j),w)
         ShowSeis(index(j))
      end
   end
end   

% ----------------------------------------------------------






function UnselectPatchContents(hObj)
global Seis
[z, index] = GetCoordVector;
x = get(hObj,'XData');
y = get(hObj,'YData');
w = x + y*i;

if ~isempty(z)
   for j = 1:length(z)
      if inside(z(j),w)
         HideSeis(index(j))
      end
   end
end   
% ----------------------------------------------------------






function ChangeVisibility(index)
global Seis
   
if Seis(index).Hidden
   ShowSeis(index)
else
   HideSeis(index)
end 
% ----------------------------------------------------------






function ShowSeis(index)
global Seis
global PlotState

   if ~isempty(Seis(index).MapSta)
      if strcmp( get(Seis(index).MapSta,'visible'), 'off'),return,end
   end
   
   if ~isempty(Seis(index).MapEvent)
      if strcmp( get(Seis(index).MapEvent,'visible'), 'off'),return,end
   end
   

   Seis(index).Hidden = 0;
   set(Seis(index).TraceHandle,'visible','on')
   if PlotState.ShowPicks
      for k=1:Seis(index).Npicks
         set(Seis(index).Pick(k).LineHandle,'visible','on')
         set(Seis(index).Pick(k).TextHandle,'visible','on')
      end
   end
   if PlotState.ShowNames
      set(Seis(index).NameHandle,'visible','on')
   end
   set(Seis(index).MapSta,'color','b','fontsize',8)
% ----------------------------------------------------------







function HideSeis(index)
global Seis

   Seis(index).Hidden = 1;
   set(Seis(index).MapSta,'color',[.7 .7 .7],'fontsize',6)
   set(Seis(index).NameHandle,'visible','off')
   for k=1:Seis(index).Npicks
      set(Seis(index).Pick(k).TextHandle,'visible','off')
      set(Seis(index).Pick(k).LineHandle,'visible','off')
   end
   set(Seis(index).TraceHandle,'visible','off')
% ----------------------------------------------------------





function SelectAll
global Seis

for j=1:length(Seis)
   ShowSeis(j)
end
% ----------------------------------------------------------





function SelectNone
global Seis
for j=1:length(Seis)
   HideSeis(j)
end
% ----------------------------------------------------------





function SelectRegion
global Seis
global EvStaMapPatchList

[xx,yy]=getline(gcf,'closed');

h = patch(xx,yy,'m');
set(h,'erasemode','xor')
if isempty(EvStaMapPatchList)
   EvStaMapPatchList(1) = h;
else
   N = length(EvStaMapPatchList);
   EvStaMapPatchList(N+1) = h;
end      
% ----------------------------------------------------------






 
function AddToStack(xlimits,ylimits)
global NumEvStaMapZooms
global XstackEvStaMap
global YstackEvStaMap

NumEvStaMapZooms = NumEvStaMapZooms + 1;
XstackEvStaMap(NumEvStaMapZooms,:) = xlimits;
YstackEvStaMap(NumEvStaMapZooms,:) = ylimits;
% --------------------------------------------------------------------




function PopOffStack
global NumEvStaMapZooms
global XstackEvStaMap
global YstackEvStaMap

if NumEvStaMapZooms < 1, return, end

set(gca,'xlim', XstackEvStaMap(NumEvStaMapZooms,:) );
set(gca,'ylim', YstackEvStaMap(NumEvStaMapZooms,:) );
NumEvStaMapZooms = NumEvStaMapZooms -1;

% --------------------------------------------------------------------






function result = InH1Quadrant(Cmpaz)

if abs( sin(Cmpaz*pi/180) ) < sin(pi/4)
   result = 1;
else
   result = 0;
end
return
% --------------------------------------------------------------------






function result = InH2Quadrant(Cmpaz)

if abs( sin(Cmpaz*pi/180) ) >= sin(pi/4)
   result = 1;
else
   result = 0;
end
return
% --------------------------------------------------------------------






                