function prsPickWin(action)
global PickWin
global ScaleFactor
global PlotState
global Seis
global MinWindowDim

MinWindowDim = 0.0001;

switch (action)

   case 'create'
       h = findobj('Tag' ,'RecSecAxis');
       if isempty(h),return,end
       axes(h)
       if ~isempty(PickWin)
          SetPickWinVisibility('on')
          h = findobj('Tag','PickWindow');
          set(h,'visible','on')
          return
       end
       if strcmp(PlotState.TimeUnits , 'Minutes')
          PickWin.Width = 10 / 60;
       else
          PickWin.Width = 10;
       end
       PickWin.Height = ScaleFactor;
       MakeSortedSeisIndexArray
       [PickWin.YCenter, index] = ShortestDist;
       PickWin.XCenter = CenteredOnTrace(index);
       PickWin.Current = 1;
       PickWin.NewIndex = 1;

       
       if PickWin.Width <= 0,PickWin.Width = MinWindowDim;end
       if PickWin.Height <= 0, PickWin.Height = MinWindowDim;end
       w2 = PickWin.Width / 2;
       h2 = PickWin.Height / 2;
       cx = PickWin.XCenter;
       cy = PickWin.YCenter;
       w3 = w2 * 1.3;
       h3 = h2 * 1.3;
       xv = [cx-w2, cx+w2, cx+w2, cx-w2, cx-w2];
       yv = [cy-h2, cy-h2, cy+h2, cy+h2, cy-h2];
       xv2= [cx-w3, cx+w3, cx, cx+w3, cx-w3];
       yv2= [cy+h3, cy-h3, cy, cy+h3, cy-h3];
       
       PickWin.Rect = line(xv,yv,'erasemode','xor','color','c','LineWidth',3);
       PickWin.Draghandle = line(xv2,yv2,'color','m','erasemode','xor');
       PickWin.ULhandle = line(xv(4),yv(4),'marker','square',...
                          'markersize',6,'color','k','erasemode','xor');
       PickWin.URhandle = line(xv(3),yv(3),'marker','square',...
                          'markersize',6,'color','k','erasemode','xor');
       PickWin.LRhandle = line(xv(2),yv(2),'marker','square',...
                          'markersize',6,'color','k','erasemode','xor');
       PickWin.LLhandle = line(xv(1),yv(1),'marker','square',...
                          'markersize',6,'color','k','erasemode','xor');
       PickWin.DragWin = 0;
       PickWin.ULResize = 0;
       PickWin.URResize = 0;
       PickWin.LLResize = 0;
       PickWin.LRResize = 0;
       
       PickWin.NewT = cx;
       PickWin.NewD = cy;
       
       a = figure('Units','normalized', ...
	'Color',[0.8 0.8 0.8], ...
        'WindowButtonDownFcn','prsPickWinMouseCallBacks(''btnDown'')',... 
        'WindowButtonMotionFcn','prsPickWinMouseCallBacks(''btnMove'')',...
        'WindowButtonUpFcn','prsPickWinMouseCallBacks(''btnUp'')',...
	'Position',[0.01 0.45 0.4 0.5], ...
	'NumberTitle','off',...
	'Name','Pick Window',...
	'Menubar','none',...
	'Tag','PickWindow');

        b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.0    0.93    1.0    0.07], ...
	'Style','frame', ...
	'Tag','Frame1');

        b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[.02 .94 .16 .05], ...
	'String','<< Previous', ...
	'Callback','prsPickWinMouseCallBacks(''PreviousSeis'')',...
	'Tag','PreviousSeis');

        b = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'Position',[.82 .94 .16 .05], ...
	'String','Next >>', ...
	'Callback','prsPickWinMouseCallBacks(''NextSeis'')',...
	'Tag','NextSeis');

        b = axes('Parent',a, ...
	'Units','normalized', ...
	'Box','on', ...
	'Color',[1 1 1], ...
	'Position',[0.1414    0.0755    0.7551    0.8], ...
	'Tag','PickingAxis', ...
	'XColor',[0 0 0], ...
	'YColor',[0 0 0]);
        ylabel(['Distance (' PlotState.DistanceUnits ')'])
        xlabel(['Time (' PlotState.TimeUnits ')'])


%   This is the pick list that pops up when a pick is being modified.	
         c = uicontrol('Parent',a, ...
	'Units','normalized', ...
	'BackgroundColor',[0.701961 0.701961 0.701961], ...
	'Position',[0.5    0.5    0.1184    0.03], ...
	'String','P', ...
	'Style','popupmenu', ...
	'Callback','global prsPickWinWaitForPick, prsPickWinWaitForPick = 0;',...
	'Visible', 'off',...
	'interruptible','off',...
	'Tag','prsPickWinPickList');
	 hPickList = findobj('Tag','PickList');
         set( c,'string',get(hPickList,'string') );

	

%  This popup holds the header values for assignment
        c = uicontrol('Parent',a, ...
 	'Units','normalized', ...
	'BackgroundColor',[1 1 1], ...
	'Position',[0.0    0.0    0.1    0.03], ...
	'Style','popupmenu', ...
	'interruptible','off',...
	'visible','off',...
	'Callback','global prsPickWinWaitForHdr, prsPickWinWaitForHdr = 0;',...
	'Tag','prsPickWinHdrPopUp'); 
         hHeaderList = findobj('Tag','pickMarkerPopUp');
         set( c,'string',get(hHeaderList,'string') );


        index = PickWin.IndexArray(1);
        Xdata = get(Seis(index).TraceHandle,'Xdata');
        Ydata = get(Seis(index).TraceHandle,'Ydata');
        PickWin.TraceHandle = line(Xdata,Ydata,'erasemode','background');
        PickWin.Npicks = Seis(index).Npicks;
        for j=1:PickWin.Npicks
           PickWin.Pick(j).Header = Seis(index).Pick(j).Header;
           PickWin.Pick(j).Phase = Seis(index).Pick(j).Phase;
           Xdata = get(Seis(index).Pick(j).LineHandle,'Xdata');
           PickWin.Pick(j).Text1 = text(Xdata(1),0, PickWin.Pick(j).Phase,...
                                   'erasemode','xor','clipping','on');
           PickWin.Pick(j).Text2 = text(Xdata(1),2,PickWin.Pick(j).Header,...
                                   'erasemode','xor','clipping','on'); 
           PickWin.Pick(j).LineHandle = line(Xdata, [-1 1],'color','r',...
                                        'erasemode','xor');
        end 
        PickWin.Selected = 0;                                                         
        xlim = [cx-w2, cx+w2];
        ylim = [cy-h2, cy+h2];
        range = ylim(2) - ylim(1);
        PickMarkerSize = range / 5;
        lower = ylim(1) + 2 * PickMarkerSize;
        upper = ylim(1) + 3 * PickMarkerSize;
        PickLim = [lower upper];
        for j=1:PickWin.Npicks
           set(PickWin.Pick(j).LineHandle,'Ydata',PickLim)
           pos = get(PickWin.Pick(j).Text1,'Position');
           pos(2) = lower;
           set(PickWin.Pick(j).Text1,'Position', pos)
           pos(2) = upper;
           set(PickWin.Pick(j).Text2,'Position', pos)
        end   

        set(b,'xlim',xlim,'ylim',ylim)
        PickWin.AxisHandle = b;
        PlotTitle = [Seis(index).Name '  ' Seis(index).Component];
        title(PlotTitle)

      
   case 'hide'
       if ~isempty(PickWin)
          SetPickWinVisibility('off')
          h = findobj('Tag','PickWindow');
          set(h,'visible','off')
          return
       end
       
   case 'MoveTo'
      Dt = PickWin.NewT - PickWin.XCenter;
      Dd = PickWin.NewD - PickWin.YCenter;
      MovePickWin(Dt,Dd);
      
   case 'ValidateDrag'
      h = findobj('Tag','RecSecAxis');
      Xlim = get(h,'Xlim');
      Ylim = get(h,'Ylim');
   
      XUl = get(PickWin.ULhandle,'Xdata');
      YUl = get(PickWin.ULhandle,'Ydata');
      XUr = get(PickWin.URhandle,'Xdata');
      YLr = get(PickWin.LRhandle,'Ydata');
   
      if XUl < Xlim(1)
         Dt = Xlim(1) - XUl;
         MovePickWin(Dt,0);
      end
   
      if YUl > Ylim(2)
         Dd = Ylim(2) - YUl;
         MovePickWin(0,Dd);
      end
   
      if XUr > Xlim(2)
         Dt = Xlim(2) - XUr;
         MovePickWin(Dt,0);
      end
   
      if YLr < Ylim(1)
         Dd = Ylim(1) - YLr;
         MovePickWin(0,Dd);
      end
      MoveWinToClosestTrace
   
   case 'Resize'
      Dt = abs(PickWin.NewT - PickWin.XCenter) - PickWin.Width/2;
      Dd = abs(PickWin.NewD - PickWin.YCenter) - PickWin.Height/2;
      ResizePickWin(Dt,Dd);
                          
   otherwise, return
   
end
% -------------------------------------------------------------------------







function MovePickWin(Dt,Dd)
global PickWin

      Xdata = get(PickWin.Rect,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.Rect,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.Rect,'Xdata',Xdata,'Ydata',Ydata)
      Xdata = get(PickWin.ULhandle,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.ULhandle,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.ULhandle,'Xdata',Xdata,'Ydata',Ydata)
      Xdata = get(PickWin.URhandle,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.URhandle,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.URhandle,'Xdata',Xdata,'Ydata',Ydata)
      Xdata = get(PickWin.LRhandle,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.LRhandle,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.LRhandle,'Xdata',Xdata,'Ydata',Ydata)
      Xdata = get(PickWin.LLhandle,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.LLhandle,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.LLhandle,'Xdata',Xdata,'Ydata',Ydata)
      Xdata = get(PickWin.Draghandle,'Xdata');
      Xdata = Xdata + Dt;
      Ydata = get(PickWin.Draghandle,'Ydata');
      Ydata = Ydata + Dd;
      set(PickWin.Draghandle,'Xdata',Xdata,'Ydata',Ydata);
      PickWin.XCenter = PickWin.XCenter + Dt;
      PickWin.YCenter = PickWin.YCenter + Dd;
% -------------------------------------------------------------------------





function ResizePickWin(Dt,Dd)
global PickWin
global MinWindowDim

NewWidth = PickWin.Width + 2*Dt;
if NewWidth < MinWindowDim, return, end
PickWin.Width = NewWidth;
NewHeight = PickWin.Height + 2*Dd;
if NewHeight < MinWindowDim, return, end
PickWin.Height = NewHeight;

w2 = PickWin.Width / 2;
h2 = PickWin.Height / 2;
cx = PickWin.XCenter;
cy = PickWin.YCenter;
xv = [cx-w2, cx+w2, cx+w2, cx-w2, cx-w2];
yv = [cy-h2, cy-h2, cy+h2, cy+h2, cy-h2];

w3 = w2 * 1.3;
h3 = h2 * 1.3;
xv2= [cx-w3, cx+w3, cx, cx+w3, cx-w3];
yv2= [cy+h3, cy-h3, cy, cy+h3, cy-h3];
 

set(PickWin.Rect,'Xdata',xv,'Ydata',yv);
set(PickWin.ULhandle,'Xdata',xv(4),'Ydata',yv(4));
set(PickWin.URhandle,'Xdata',xv(3),'Ydata',yv(3));
set(PickWin.LRhandle,'Xdata',xv(2),'Ydata',yv(2));
set(PickWin.LLhandle,'Xdata',xv(1),'Ydata',yv(1));
set(PickWin.Draghandle,'Xdata',xv2,'Ydata',yv2);


h= findobj('Tag','PickingAxis');
xlim = [cx-w2 cx+w2];
ylim = [cy-h2 cy+h2];
set(h,'xlim',xlim,'ylim',ylim)

% -------------------------------------------------------------------------







function SetPickWinVisibility(state)
global PickWin

    set(PickWin.Rect , 'visible',state);
    set(PickWin.ULhandle  , 'visible',state);
    set(PickWin.URhandle , 'visible',state);
    set(PickWin.LRhandle , 'visible',state);
    set(PickWin.LLhandle , 'visible',state);
    set(PickWin.Draghandle , 'visible',state);
% -------------------------------------------------------------------------





function [result, index] = ShortestDist
global Seis
global PlotState


index = 1;
result = 10000000;
for j=1:length(Seis)
   if Seis(j).Dist < result
      result = Seis(j).Dist;
      index = j;
   end
end

if strcmp(PlotState.DistanceUnits, 'Degrees')
   result = Seis(index).Gcarc;
end
% -------------------------------------------------------------------------



       


function result = CenteredOnTrace(index)

h = findobj('Tag' ,'RecSecAxis');
xlim = get(h,'Xlim');
result = mean(xlim);
% -------------------------------------------------------------------------



       


function MoveWinToClosestTrace
global Seis
global PickWin
global PlotState

Dmin = 1000000;
for j=1:length(Seis)
   if strcmp(PlotState.DistanceUnits, 'Degrees')
      delta = Seis(j).Gcarc - PickWin.YCenter;
   else
      delta = Seis(j).Dist - PickWin.YCenter;
   end
   if abs(delta) < abs(Dmin)
      Dmin = delta;
      index = j;
   end
end   

if Dmin ~= 0		% jump to next trace
   MovePickWin(0,Dmin)
   PickWin.NewIndex = find(PickWin.IndexArray == index);
end
prsUpdateSingleTraceWindow('manual')
% -------------------------------------------------------------------------






% IndexArray is an array of indices to Seis sorted (ascending) by distance.
function MakeSortedSeisIndexArray
global Seis
global PickWin

Dist = zeros(length(Seis),1);

for j=1:length(Seis)
   Dist(j) = Seis(j).Dist;
end
[Dist, IndexArray] = sort(Dist);
PickWin.IndexArray = IndexArray;
% -------------------------------------------------------------------------





              