function prsSetPicksCallbacks(value)
global ToolBarBtn
global Seis
global PlotState
global WAITFORQUIT
global PhaseList
global PhasePatch

switch value

   case 'select'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(1) = 1;
      prsPickWin('hide')
      return 
      
   case 'zoomin'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(2) = 1;
      prsPickWin('hide')
      return 
      
   case 'zoomout'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(3) = 1; 
      prsPickWin('hide')
      return 
      
   case 'view'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(4) = 1; 
      prsPickWin('hide')
      return 
      
   case 'hide'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(5) = 1; 
      prsPickWin('hide')
      return 
      
   case 'filter'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(6) = 1; 
      prsPickWin('hide')
      return

   case 'pickwin'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(7) = 1;
      prsPickWin('create')
      return
     
   case 'pick'
      ToolBarBtn = zeros(8,1);
      ToolBarBtn(8) = 1;
      if PhaseList.NumPhases > 0
         if ~strcmp( get( PhasePatch.handle, 'visible'), 'on')
            CreatePickErrorRegion( 1 )
         end
      end
      prsPickWin('hide')
      return
      
   case 'Refresh'
      h = findobj('Tag','RecSecAxis');
      xlim = get(h,'xlim');
      xlim = xlim + 1;
      set(h,'xlim',xlim)
      xlim = xlim - 1;
      set(h,'xlim',xlim)
          
      
   case 'AddP'
      h = findobj('Tag','PlistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      AddPhaseLine(string(value) )
      return
      
   case 'AddS'
      h = findobj('Tag','SlistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      AddPhaseLine(string(value) )
      return
      
   case 'Addp'
      h = findobj('Tag','plistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      AddPhaseLine(string(value) )
      return
      
   case 'Adds'
      h = findobj('Tag','slistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      AddPhaseLine(string(value) )
      return
      
   case 'DelP'
      h = findobj('Tag','PlistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      DeletePhaseLine(string(value) )
      return
      
   case 'DelS'
      h = findobj('Tag','SlistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      DeletePhaseLine(string(value) )
      return
      
   case 'Delp'
      h = findobj('Tag','plistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      DeletePhaseLine(string(value) )
      return
      
   case 'Dels'
      h = findobj('Tag','slistBox');
      if isempty(h), return, end
      string = get(h,'string');
      value = get(h,'value');
      DeletePhaseLine(string(value) )
      return
      
   case 'Orientation'
      h = findobj('Tag','ViewOrientation');
      if isempty(h), return, end
      string = get(h,'label');
      hAxis = findobj('Tag','RecSecAxis');
      if strcmp(string, 'View Horizontal')
         set(h,'label','View Vertical')
         set(hAxis,'view',[0 90])
         
      else
         set(h,'label','View Horizontal')
         set(hAxis,'view',[90 -90])
      end
      
      hh = findobj('Tag','HscrollBar');
      hv = findobj('Tag','VscrollBar');
      ph = get(hh,'position');
      pv = get(hv,'position');
      tmp = ph;
      ph = pv;
      pv = tmp;
      set(hh,'position',ph)
      set(hv,'position',pv)

      return
      
   case 'TraceMarkers'
      h = findobj('Tag','ViewMarkers');
      if isempty(h), return, end
      if PlotState.ShowPlaceHolders
          PlotState.ShowPlaceHolders = 0;
          set(h,'label','View Trace Markers')
          for j=1:length(Seis)
             if Seis(j).Hidden
                set(Seis(j).TraceMarker,'visible','off')
             end
          end
      else 
          PlotState.ShowPlaceHolders = 1;
          set(h,'label','Hide Trace Markers')
          for j=1:length(Seis)
             if Seis(j).Hidden
                set(Seis(j).TraceMarker,'visible','on')
             end
          end
      end
      
   case 'Names'
      h = findobj('Tag','ShowNames');
      if isempty(h), return, end
      if PlotState.ShowNames
         PlotState.ShowNames = 0;
         set(h,'label','View Station Names')
         for j=1:length(Seis)
            set(Seis(j).NameHandle,'visible','off')
         end
      else
         PlotState.ShowNames = 1;
         set(h,'label','Hide Station Names')
         for j=1:length(Seis)
            if ~Seis(j).Hidden
               set(Seis(j).NameHandle,'visible','on')
            end
         end
      end
         
   case 'Picks'
      h = findobj('Tag','ViewPicks');
      if isempty(h), return, end
      if PlotState.ShowPicks
         PlotState.ShowPicks = 0;
         set(h,'label','View Picks')
         for j=1:length(Seis)
            for k=1:Seis(j).Npicks
               set(Seis(j).Pick(k).LineHandle,'visible','off')
               set(Seis(j).Pick(k).TextHandle,'visible','off')
            end
         end
      else
         PlotState.ShowPicks = 1;
         set(h,'label','Hide Picks')
         for j=1:length(Seis)
            if ~Seis(j).Hidden
               for k=1:Seis(j).Npicks
                  set(Seis(j).Pick(k).LineHandle,'visible','on')
                  set(Seis(j).Pick(k).TextHandle,'visible','on')
               end
            end
         end
      end
      
   case 'SavePicks'
      SavePicks   

   case 'Close'
      close
      close
      WAITFORQUIT = 0;
      return

   otherwise
      return 

end
% ---------------------------------------------------------------------






function AddPhaseLine( phase )
global SourceDepth
global DistanceVec
global PhaseList
global PlotState
global Seis

Phase = phase{1};


% Don't add a phase already displayed
for j=1:PhaseList.NumPhases
   if strcmp(phase, PhaseList.DisplayedPhase{j}),return,end
end
   
[tt,jnk1,jnk2,jnk3] = get_ttt(Phase, SourceDepth, DistanceVec,'iasp91');
if strcmp(PlotState.DistanceUnits , 'Degrees')
   dist = DistanceVec;
else
   for k=1:length(Seis)
      dist(k) = Seis(k).Dist;
   end
   dist = sort(dist);
end

if strcmp(PlotState.TimeUnits , 'Minutes')
   tt = tt / 60;
end 
[d,t] = StripInf(dist, tt);
if isempty(d),return,end
h = findobj('Tag','RecSecAxis');
axes(h);
h1 = line(t, d,'color','r','erasemode','background');
PhaseList.NumPhases = PhaseList.NumPhases + 1;
PhaseList.hPhase(PhaseList.NumPhases) = h1;
[dm, ii] = max(d);
PhaseList.DisplayedPhase{PhaseList.NumPhases} = phase;
PhaseList.HeaderName(PhaseList.NumPhases) = GetNextAvailableHeaderName;		      

% ---------------------------------------------------------------------







function DeletePhaseLine( phase )
global PhaseList
global PhasePatch


Phase = phase{1};
if PhaseList.NumPhases < 1, return, end
 
for j=1:PhaseList.NumPhases
   if strcmp(phase, PhaseList.DisplayedPhase{j})
      if j == PhasePatch.PhaseIndex
         set(PhasePatch.handle,'visible','off')
      end
      delete( PhaseList.hPhase(j) )
      PhaseList.hPhase(j) = [];
      PhaseList.DisplayedPhase(j) = [];
      PhaseList.HeaderName(j) = [];
      if PhasePatch.PhaseIndex >= j
         PhasePatch.PhaseIndex = PhasePatch.PhaseIndex - 1;
      end
      PhaseList.NumPhases = PhaseList.NumPhases - 1;
      return;
   end
end
% ---------------------------------------------------------------------






function [d,t] = StripInf(DistanceVec, tt)

ii = find( ~isinf(tt) );
  if isempty(ii)
    d=[];
    t=[];
    return;
else
    d = DistanceVec(ii);
    t = tt(ii);
    return
end
% ---------------------------------------------------------------------




  

function CreatePickErrorRegion( index )
global PickTolerance
global PhasePatch
global PhaseList

hPhase = PhaseList.hPhase(index);
Xdata = get(hPhase,'Xdata');
Ydata = get(hPhase,'Ydata');

X = [Xdata+PickTolerance, fliplr(Xdata)-PickTolerance];
Y = [Ydata, fliplr(Ydata)];
set(PhasePatch.handle,'Xdata',X)
set(PhasePatch.handle,'Ydata',Y)
set(PhasePatch.handle,'visible','on')
PhasePatch.DisplayedPhase = PhaseList.DisplayedPhase{ index };
PhasePatch.HeaderName = PhaseList.HeaderName( index );
PhasePatch.PhaseIndex = index;
% ---------------------------------------------------------------------




   

function value = GetNextAvailableHeaderName
global HeaderNameAvailable 

value = 1;
for j=1:11
   if HeaderNameAvailable(j)
      HeaderNameAvailable(j) = 0;
      value = j;
      return
   end
end
% ---------------------------------------------------------------------




   
function SavePicks
global Seis
global SACdata

for j=1:length(Seis)
      SACdata(j).times.a   = [];
      SACdata(j).times.ka  = [];
      SACdata(j).times.t0  = [];
      SACdata(j).times.kt0 = [];
      SACdata(j).times.t1  = [];
      SACdata(j).times.kt1 = [];
      SACdata(j).times.t2  = [];
      SACdata(j).times.kt2 = [];
      SACdata(j).times.t3  = [];
      SACdata(j).times.kt3 = [];
      SACdata(j).times.t4  = [];
      SACdata(j).times.kt4 = [];
      SACdata(j).times.t5  = [];
      SACdata(j).times.kt5 = [];
      SACdata(j).times.t6  = [];
      SACdata(j).times.kt6 = [];
      SACdata(j).times.t7  = [];
      SACdata(j).times.kt7 = [];
      SACdata(j).times.t8  = [];
      SACdata(j).times.kt8 = [];
      SACdata(j).times.t9  = [];
      SACdata(j).times.kt9 = [];
      
   for k=1:Seis(j).Npicks
      if strcmp(Seis(j).Pick(k).Header, 'A')
         SACdata(j).times.a = Seis(j).Pick(k).Time;
         SACdata(j).times.ka = Seis(j).Pick(k).Phase;
      end
      if strcmp(Seis(j).Pick(k).Header, 'T0')
         SACdata(j).times.t0 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt0 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T1')
         SACdata(j).times.t1 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt1 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T2')
         SACdata(j).times.t2 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt2 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T3')
         SACdata(j).times.t3 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt3 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T4')
         SACdata(j).times.t4 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt4 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T5')
         SACdata(j).times.t5 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt5 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T6')
         SACdata(j).times.t6 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt6 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T7')
         SACdata(j).times.t7 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt7 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T8')
         SACdata(j).times.t8 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt8 = char(Seis(j).Pick(k).Phase);
      end
      if strcmp(Seis(j).Pick(k).Header, 'T9')
         SACdata(j).times.t9 = Seis(j).Pick(k).Time;
         SACdata(j).times.kt9 = char(Seis(j).Pick(k).Phase);
      end
   end
end
% ---------------------------------------------------------------------




function AddToA(index, Pick )


% ---------------------------------------------------------------------





keyboard