function prsSlider
% Display progress information. This control displays progress using a
% thermometer-like device. At the beginning of the operation the slider is
% all blue. As steps are completed the blue area is covered with red
% until at the conclusion of the operation the slider is all red. The slider
% is implemented as a figure with a frame enclosing two colored frames; one
% blue and one red. This function sets up these controls.

 
global hSLIDERWIN               % handle to progress slider control
global hSLIDERDONE              % handle to done fraction
global hSLIDERTOTAL             % handle to total fraction of slider control

Width=0.2;
Height=0.1;

hSLIDERWIN = figure('Units','normalized', ...
	'Color',[0.9 0.9 0.9], ...
	'Position',[.1 (1-Height)/2 Width Height], ...
	'NumberTitle','off',...
	'Name','Rendering Plot data',...
	'Menubar','none',...
	'Tag','Slider');
set(hSLIDERWIN,'Resize','off')



uicontrol('style','frame',...
          'units','normalized',...
          'position',[0.02 0.02 .96 .96]);
          
hSLIDERTEXT=uicontrol('style','text',...
                      'units','normalized',...
                      'position',[0.03,0.7,0.94,0.2],...
                      'Fontsize',12,...
                      'string','Working...');
                      
hSLIDERTOTAL=uicontrol('style','frame',...
                       'units','normalized',...
                       'position',[.04 .25 .92 .2],...
                       'backgroundcolor','b');
        
hSLIDERDONE=uicontrol('style','frame',...
                      'units','normalized',...
                      'position',[.04 .25 .01 .2],...
                      'backgroundcolor','r');


